#!/usr/bin/tclsh

lassign $argv skip recsz order inf outf

set in [open $inf r]
fconfigure $in -translation binary
set out [open $outf w]
fconfigure $out -translation binary

seek $in $skip
while {![eof $in]} {
 set rec [read $in $recsz]
 set sz [string length $rec]
 if {$sz == 0} break
 if {$sz != $recsz} {
  puts stderr "incomplete record $sz/$recsz"
  break
 }
 set o {}
 foreach i $order {
  if {$i eq "p"} {
   lappend o 0
  } else {
   binary scan $rec @${i}cu ov
   lappend o $ov
  }
 }
 set orec [binary format c* $o]
 puts -nonewline $out $orec
}
